#Simple closure for the clicked function of a widget.
#on is 1 if a button was pressed down or 0 if released.
#This might get taken out:
#aspect is "other information" -- for instance, which part of a widget
#got clicked.

class ClickedFunction:
    def __init__(self, widget, function, on):
        self.widget = widget
        self.function = function
        self.on = on
        #print "Creating ClickedFunction with on = %d"%self.on
    def __call__(self, e):
        self.function(self.widget, e, self.on)

def Connect(canvas, id_or_tag, button, obj, func):
    #Binds button-down to obj.func(event, 1)
    #and button-up to obj.func(event, 0)
    [canvas.tag_bind(id_or_tag, event, ClickedFunction(obj, func, on))
     for (event, on) in
     [("<Button-%d>"%button, 1),("<ButtonRelease-%d>"%button,0)]]

if __name__ == "__main__":
    class Widget:
        def __init__(self):
            pass

        def func(self, event, on):
            print "Called with on = ", on

    w = Widget()
    c = ClickedFunction(w, Widget.func, 1)
    c(1)
    c(0)
