from Tkinter import Tk, Canvas

class Connection:
    INPUTNAMES=["cli", "stdin", "ctrli"]
    OUTPUTNAMES=["stdout", "stderr"]
    #If something is attached to a widget on the stdin or ctrli aspect,
    # that something is that widget's parent.
    PARENTNAMES=["ctrli", "stdin"]
    def __init__(self, canvas, jw1, jwa1, jwn1, jw2, jwa2, jwn2, line):
        self.canvas = canvas
        self.widget1 = jw1
        self.connectpt1 = jwa1
        self.name1 = jwn1
        self.widget2 = jw2
        self.connectpt2 = jwa2
        self.name2 = jwn2
        self.line = line
        self.UpdateLine() #Alter locations here
    def UpdateLine(self):
        #tag-lower puts the line behind the connection box
        jwcp1loc = self.canvas.bbox(self.connectpt1)
        self.loc1 = [(jwcp1loc[0]+jwcp1loc[2])/2, (jwcp1loc[1]+jwcp1loc[3])/2]
        jwcp2loc = self.canvas.bbox(self.connectpt2)
        self.loc2 = [(jwcp2loc[0]+jwcp2loc[2])/2, (jwcp2loc[1]+jwcp2loc[3])/2]
        self.canvas.coords(self.line, self.loc1[0], self.loc1[1], self.loc2[0],
                           self.loc2[1])
        self.canvas.tag_lower(self.line,self.connectpt1)
        self.canvas.tag_lower(self.line,self.connectpt2)
    def __str__(self):
        print "Connection(%s, %s, %s, %s)"%(jw1, jwn1, jw2, jwn2)
    def Connects(self, jw):
        if self.widget1 == jw or self.widget2 == jw: return True
        else: return False
    def OtherWidget(self, jw):
        if self.widget1 == jw: return self.widget2
        elif self.widget2 == jw: return self.widget1
        else: return None
    #Changing my mind. The following function should be changed to go in
    #  JetWidget:
    def BackwardsFrom(self, jw):
        if (self.jw1 == jw and self.connectpt1.label in PARENTNAMES) or\
           (self.jw2 == jw and self.connectpt2.label in PARENTNAMES):
            return True
        else:
            return False
    def ConnectsFrom(self, jw):
        if (self.widget1 == jw and self.name1 in OUTPUTNAMES)\
           or (self.widget2 == jw and self.name2 in OUTPUTNAMES): return True
        else: return False
    def ConnectsToAspect(self, jwn):
        if self.name1 == jwn: return self.widget1
        elif self.name2 == jwn: return self.widget2
        else: return False
    def ConnectsToStdin(self, jw):
        if (self.widget1 == jw and self.name1 == "stdin")\
           or (self.widget2 == jw and self.name2 == "stdin"): return True
        else: return False
    def Destroy(self):
        self.canvas.delete(self.line)
        self.widget1.DelConnection(self.name1)
        self.widget2.DelConnection(self.name2)
        
            
