from Tkinter import Tk, Canvas
from ClickedFunction import *

class ConnectionPoint:
    """A connection point for a widget. NOT TO BE USED INDEPENDENTLY OF
    WIDGET or subclasses."""
    def __init__(self, jetw, canvas, loc, size, label, tag):
        """jetw = widget which this serves as a connection for.
        loc = [x,y] is the location of the connection point widget.
        size = [w,h] is the size of the connection point widget.
        tag = the tag that the connection point widget should be labeled with
        (to move with the rest of the widget)."""
        self.parent = jetw
        self.id = canvas.create_rectangle(loc[0], loc[1], size[0], size[1],
                                          fill = "Light blue")
        self.tag = tag
        self.label = label
        self.canvas = canvas
        self.loc = loc
        self.canvas.addtag_withtag(tag, self.id)

        #OK, Ethan, maybe you love list comprehensions a LITTLE TOO much, hmm?
        #What this does is bind Button-1 to self.leftclicked(1),
        #ButtonRelease-1 to self.leftclicked(0), Button-2 to
        #self.middleclicked(1), ButtonRelease-2 to self.middleclicked(0), etc.
        [[self.canvas.tag_bind(self.id, event,
                          ClickedFunction(self, func, on))
          for (event, on) in [("<Button-%d>"%n,1), ("<ButtonRelease-%d>"%n,0)]]
         for (func, n) in [(ConnectionPoint.leftclicked, 1),
                           (ConnectionPoint.middleclicked, 2),
                           (ConnectionPoint.rightclicked, 3)]]

        #Oh, and bind Motion to self.motion.
        self.canvas.tag_bind(self.id, "<Motion>", self.motion)
    def leftclicked(self, event, on):
        print "l"
        print self.parent, self.id, self.label
        self.parent.ClickedAspect(self.id, self.label, event, on)
    def middleclicked(self, event, on):
        print "m"
        pass #Ignore middle buttons for now
    def rightclicked(self, event, on):
        if on:
            pass
        else:
            print "r"
            self.parent.DisconnectAspect(self.label,on)
    def motion(self, event):
        self.loc = [event.x,event.y]
        self.parent.MovedAspect(self, self.label, event)
    def Destroy(self):
        """destroy from canvas"""
        self.canvas.delete(self.id)

if __name__ == "__main__":
    pass #Can't test independently of JetWidget, which sucks, but whatever.

