from Tkinter import Tk, Canvas
from JetWidget import JetWidget
from Connection import Connection
import tkMessageBox

#Graph class is big. Is there something we can do about this? I know Graph is
# a mediator, but right now we have 180 lines at least, and 19 methods
# reply = i wouldnt worry about that right now. it doesnt exceed its functionality

class Graph(Canvas):
    def __init__(self, root, callback, floater, **keys):
        """Constructor. root = root window (Tkinter),
        callback = callback called when a widget is moved,
        floater = WidgetPickList which is used to add new widgets/commands,
        keys = arguments for Tkinter Canvas constructor"""
        Canvas.__init__(self, root, keys)
        self._callback = callback
        self.widgets = []
        self.connections = []
        self.pack()
        self.floater = floater
        self.bind("<Button-1>", self._addnode)
        self.bind("<Motion>", self._mousemotion)
        #Binding right button to WriteScript just for testing purposes
        #self.bind("<Button-3>", self.WriteScript)
        self.connectstart = []
        self.connectline = None
        self.lastclicked = self.downon = None
        self.lastclickedaspectname = self.lastclickedaspect = None
        self.index = self.lastindex = 0
        #self.downon is across a single click; = what the click started on
        #self.lastclicked = last object clicked. It, self.lastclickedaspectname
        #and self.lastclickedaspect, are across a connection. These are
        #attributes of the last object clicked.
        #self.index is the index of last added widget in widgets[
        self.lastmouseloc = None
        self.bind("<Button-3>", self._clearline)

    def _delnode(self):
        """to delete widgets"""
        #perhaps i'm binding wrong? it seems that key-release events
        #might not work in tkinter
        print "check at delnode"
        if self.lastclicked == None:
            pass
        else:
            #Todo: find a way to set lastclicked to None here without
            #      breaking other functions
            self.widgets[self.lastclicked.myIndex].Destroy()
            del self.widgets[self.lastindex]
            self.index = len(self.widgets)
            i = len(self.widgets)
            i = i-1
            while (i >= 0):
                self.widgets[i].myIndex = i
                i = i-1
    def _clearline(self, event):
        if self.connectline == None:
            pass
        else:
            self.delete(self.connectline)
            self.connectline = None
            self.lastclickedaspect = None
            self.connectstart = []
            
    def AddArguments(self,args):
        """add arguments/attributes to currently selectd widget"""
        self.lastclicked.AddArguments(args)
    def MoveSelected(self,x,y):
        """move last clicked widget to specified location"""
        loc=[x, y]
        self.lastclicked.moveto(loc)
    def Armageddon(self):
        """destroy everything this poor sensitive graph holds dear"""
        for item in self.widgets:
            item.Destroy()
        for item in self.connections:
            item.Destroy()
        self.widgets = []
        self.connections = []
        self.lastclicked = self.downon = None
        self.lastclickedaspectname = self.lastclickedaspect = None
        self.delete(self.connectline)
        self.connectline = None
        self.index = self.lastindex = 0

    def WriteScript(self):
        from ScriptVisitor import WriteScriptVisitor
        v = WriteScriptVisitor()
        v.Script(self.widgets, self.connections)

    #Ugh, one-line functions are kind of lame, I should just call the
    # appropriate function. Well, I'll change it later.
    def WidgetListSelected(self):
        return self.floater.currentWidget()
    def WidgetListClear(self):
        self.floater.clear()

    def MovingLoc(self,x,y,type,attribs):
        """call the callback to display location of moving object"""
        self._callback(type,attribs,[x,y])

    #These are the functions that are called by JetWidget.
    #They basically just dispatch depending on whether the value of on is
    # true or not.
    def ClickedWidget(self, jetw, tag, event, on):
        if on: self.SetClickedWidget(jetw, tag, event)
        else: self.UnsetClickedWidget(jetw, tag, event)
    def ClickedWidgetAspect(self, jetw, aspect, label, event, on):
        if on:
            self.SetClickedWidgetAspect(jetw, aspect, label)
            self.SetClickedWidget(jetw, jetw.maintag, event)
        else:
            #Unsetting has to happen first on the aspect, because UnsetCW
            # sets lastclicked, and UnsetCWA needs that first.
            self.UnsetClickedWidgetAspect(jetw, aspect, label, event)
            self.UnsetClickedWidget(jetw, jetw.maintag, event)
    def DisconnectAspect(self, connection):
        self.connections.remove(connection)

    def SetClickedWidget(self, jetw, tag, event):
        print "set" + str(jetw)
        self.startmouseloc = self.lastmouseloc = [event.x, event.y]
        self.downon = jetw
        self.itemconfig(self.lastclicked.labelid, text=self.lastclicked.command)
        self.itemconfig(self.lastclicked.id, fill = "light blue")
        self.itemconfig(jetw.labelid, text =jetw.command) 
        self.itemconfig(jetw.id, fill = "green")
    def MovedWidget(self, jetw, tag, event):
        if self.downon != jetw or self.lastmouseloc == None:
            #Hasn't been clicked, just a harmless mouseover.
            return
        self.move(tag, event.x-self.lastmouseloc[0],
                        event.y-self.lastmouseloc[1])
        self.lastmouseloc = [event.x, event.y]
        for w in self.connections:
            if w.Connects(jetw):
                w.UpdateLine()
    def UnsetClickedWidget(self, jetw, tag, event):
        print "unset" + str(jetw)
        #Probably not needed to actually keep track of widgets, since we can
        # use the Canvas bbox() function.
        #delta = map(lambda b,c:b-c,
        #             [event.x, event.y], self.startmouseloc)
        #jetw.moveby(delta)
        self.startmouseloc = self.lastmouseloc = None
        self.lastclicked = jetw
        self.lastindex = jetw.myIndex
        self.downon = None
        self._callback(jetw.command,jetw.attribs,jetw.loc)
        #self.itemconfig(jetw.labelid, text =jetw.command) 
        #self.itemconfig(jetw.id, fill = "light blue")


    def SetClickedWidgetAspect(self, jwid, aspect, aspectname):
        print "clicked %s on the %s" % (str(jwid), aspectname)
        #self.lastclicked = jwid
        self.lastindex = jwid.myIndex
    def MovedWidgetAspect(self, jetw, aspect, label, event):
        self.MovedWidget(jetw, jetw.alltag, event)

    def UnsetClickedWidgetAspect(self, jwid, aspect, aspectname, event):
        print "unclicked on %s. aspect = %s" % (str(jwid), aspectname)
        #Function still needs badly to be sorted out, to clarify the rules
        # of adding connections.
        print "first was %s @ %s" %(self.lastclickedaspectname, str(self.lastclicked))
        print "now was %s @ %s" %(aspectname, str(jwid))

        #if self.WidgetListSelected() == None  or \
            #   self.WidgetListSelected().type != Connection:
            #Then the rest of this function is basically meaningless
            #We'd want to set self.lastclicked to jwid, but that should be done
            # in UnsetClickedWidget.
            #return

        if self.WidgetListSelected()==None:
            print "diaspara"
        try: 
            try:
                if self.lastclicked == None or self.lastclickedaspect == None:
                    print "First click"
                    #First click in a connection.
                    raise FirstWidgetException
                elif self.lastclicked == jwid:
                    #This is the second click in a connection, and user clicked
                    #same widget twice -- ignore it.
                    #Throw exception here?
                    raise WidgetClickedTwiceException
                else:
                    #Make sure connection goes from input to output
                    dict = {"input":0, "output":0}
                    for a in [aspectname, self.lastclickedaspectname]:
                        if a == "stdin" or a == "cli" or a == "ctrli":
                            dict["input"]+= 1
                            print "input"
                        else:
                            dict["output"]+= 1
                            print "output"
                    if dict["output"] == 2:
                        raise HasTwoInputsException
                    if dict["input"] == 2:
                        raise HasTwoOutputsException
                        #Problem -- input->input or output->output!
                #Other checks here would be good -- for instance, maybe a check
                #  to see if the connection makes a cycle, or maybe to see
                #  if the widget already has a connection there.
                #OK, all clear!
                #Start new connection
                self._connect(jwid, aspect, aspectname,
                             self.lastclicked, self.lastclickedaspect,
                             self.lastclickedaspectname)
            #If any exceptions happened, well, *this* click is OK.
            finally:
                self.lastclickedaspectname = aspectname
                self.lastclickedaspect = aspect
                self.lastclicked = self.downon
                self.downon = None
                
        #Might want to clean up all exceptino handling stuff with a "finally"
        # clause (see http://www.python.org/doc/2.3.4/ref/try.html)
        #Note: Might want to add an option to turn off error messages in menu
        except WidgetClickedTwiceException:
            self.delete(self.connectline)
            self.connectline = None
            self.lastclicked = None
            self.lastclickedaspect = None
            self.lastclickedaspectname = None
            self.connectstart = []
            tkMessageBox.showerror("Connection Failed",
                                   "Rejected because same widget clicked twice")
        except HasTwoInputsException:
            self.delete(self.connectline)
            self.connectline = None
            self.lastclicked = None
            self.lastclickedaspect = None
            self.lastclickedaspectname = None
            tkMessageBox.showerror("Connection Failed",
                                   "Rejected because there were two inputs")
        except HasTwoOutputsException:
            self.delete(self.connectline)
            self.connectline = None
            self.lastclicked = None
            self.lastclickedaspect = None
            self.lastclickedaspectname = None
            tkMessageBox.showerror("Connection Failed",
                                   "Rejected because there were two outputs")
        except FirstWidgetException:
            print "Rejected because this was the first widget to be clicked."
            self.connectline = self.create_line(event.x, event.y,
                                                event.x, event.y, fill = "red")
            self.connectstart = [event.x, event.y]
            self.lastclicked = jwid
            #XXX Create a line from firstclicked to wherever the mouse is..
        except AlreadyConnectedException:
            tkMessageBox.showerror("Connection Failed",
                                   "Widget already connected there!")
        else:
            #Connection actually succeeded
            self.lastclicked = None
            self.lastclickedaspect = None
            self.lastclickedaspectname = None
            self.connectstart = []


    def __repr__(self):
        return "Graph" + " " + repr(self.widgets) + \
               " " + repr(self.connections)

    #Callbacks on the graph class.
    def _mousemotion(self, event):
        if self.connectline:
            self.coords(self.connectline, self.connectstart[0],
                        self.connectstart[1], event.x-3, event.y)

    def _addnode(self,event):
        #        print SelectedWidget()
        print "Whee, adding"
        s = self.WidgetListSelected()
        print s
        if s != None and issubclass(s.type, JetWidget):
            w = (s.type)(self, s.name, event.x, event.y)
            self._add_widget(w)
            self.WidgetListClear()
        else:
            pass

    #Member functions to add widgets and connections, respectively.
    def _add_widget(self, W):
        self.widgets.append(W)
        self._callback(W.command,W.attribs,W.loc)
        W.setIndex(self.index)
        self.index = self.index + 1
        if self.lastclicked == None:
            pass
        else:
            self.itemconfig(self.lastclicked.labelid, text=self.lastclicked.command)
            self.itemconfig(self.lastclicked.id, fill = "light blue")
        self.lastclicked = W
        self.lastindex = W.myIndex
        if self.connectline == None:
            pass
        else:
            self.delete(self.connectline)
            self.connectline = None
        
    def _connect(self, jw1, jwcp1, jwn1, jw2, jwcp2, jwn2):
        "Connect two widgets on the appropriate aspects."
        print "Connecting %s's %s to %s's %s" %(str(jw1), jwn1, str(jw2), jwn2)
        for (w, a) in [(jw1, jwn1), (jw2, jwn2)]:
            if w.CanAddConnection(a) == False:
                raise AlreadyConnectedException(w)
        
        c = Connection(self, jw1, jwcp1, jwn1,
                      jw2, jwcp2, jwn2, self.connectline)
        self.connections.append(c)
        jw1.AddConnection(c, jwn1)
        jw2.AddConnection(c, jwn2)
        self.connectstart = []
        self.connectline = None
        print self.connections
        
        

class WidgetClickedTwiceException(Exception):
    pass
class HasTwoInputsException(Exception):
    pass
class HasTwoOutputsException(Exception):
    pass
class FirstWidgetException(Exception):
    pass
class AlreadyConnectedException(Exception):
    def __init__(self, wid):
        self.w = wid

if __name__ == "__main__":
    root = Tk()
    from ScrollList import WidgetPickList
    global picklist
    picklist = WidgetPickList(Tk(),lambda a: None)
    g = Graph(root, picklist)
    g.pack()
    g.bind("<Destroy>", lambda e: picklist.master.destroy())

    print g
    root.mainloop()
