#! /usr/bin/python
"""
GUI for writing shell scripts
"""

__author__= "Jelani John & Ethan Glasser-Camp"

from Tkinter import *
from ScrollList import *
from Menu import *
from Graph import *
from WidgetInfo import *
from SaveLoad import *
import sys
import os

class App(Frame):


    
    def __init__ (self, master=None ):
        Frame.__init__(self,master)
        self.grid()
        self.__createWidgets()
        self.bind("<Destroy>", lambda b: self.floater.master.destroy())
        self._lastFileName = None
        
      
    def __createWidgets(self):
        #Tooltip label on bottom
        self.__tooltip = Label(self, text ="Welcome to JetWidget :)", fg="coral", bg="black")
        self.__tooltip.grid (row=3, column=1, pady=5)

        #Widget list
        global picklist
        self.floater = WidgetPickList(self,self.__callbackWidget)
        self.floater.grid (row=2,column=0)

        #Canvas
        self.__canvas = Graph (self, self.__callbackGraph, self.floater,
                               bg="white", height=600, width=500)
        self.__canvas.grid ( row=1, rowspan=2, column=1 )

        #Menu
        self.__menu = createMenuBar(self, self.__callbackMenu)
        self.__menu.grid(row=0,column=1)

        #WidgetInfo
        self.__wInfo = WidgetInfo(self,self.__callbackWInfo,self.__argback)
        self.__wInfo.grid(row=1,column=0)

        #Custom Button
        Button(self, text="Create Custom Widget",
               command=self.floater._insertCustomWidget).grid(row=3,column=0)

        #Delete Button
        Button(self, text="Delete Widget",
               command=self.__canvas._delnode).grid(row=0,column=0)


    
    def __setTooltip(self,text):
        self.__tooltip["text"]=text
    
    #Callbacks                
    def __callbackWidget(self,i):
        pass

    def WriteScript(self):
        self.__canvas.WriteScript()
    def __callbackMenu(self,i):
        "saves or loads the canvas"
        #todo - modify saveload.py for connections
        if i=="s":
            self._lastFileName = saveCanvas(self.__canvas.widgets,
                                            self.__canvas.connections,
                                            self._lastFileName)
            self.__setTooltip(self._lastFileName)
        elif i=="sa":
            self._lastFileName = saveCanvasAs(self.__canvas.widgets,
                                              self.__canvas.connections)
            self.__setTooltip(self._lastFileName)
        elif i=="l":
            widgetInfo = loadCanvas(self.__setTooltip)
            if widgetInfo == None:
                pass
            self.__canvas.Armageddon()
            for item in widgetInfo[0]:
                self.__canvas._add_widget(JetWidget(self.__canvas,item[2],int(item[0]),int(item[1]),item[3]))
            for item in widgetInfo[1]:
                self.__canvas.connectline=self.__canvas.create_line(self.__canvas.widgets[int(item[0])].aspectdict.get(item[2]).loc[0],
                                                                    self.__canvas.widgets[int(item[0])].loc[1],
                                                                    self.__canvas.widgets[int(item[0])].loc[0],
                                                                    self.__canvas.widgets[int(item[0])].loc[1])
                
                self.__canvas.connectstart= [self.__canvas.widgets[int(item[0])].loc[0],
                                             self.__canvas.widgets[int(item[0])].loc[1]]
                self.__canvas._connect(self.__canvas.widgets[int(item[0])],
                                       self.__canvas.widgets[int(item[0])].aspectdict.get(item[2]).id,
                                       item[2],
                                       self.__canvas.widgets[int(item[1])],
                                       self.__canvas.widgets[int(item[1])].aspectdict.get(item[3]).id,
                                       item[3])
            widgetInfo = []
        else:
            pass
    def __callbackWInfo(self,x,y):
        self.__canvas.MoveSelected(x,y)
    def __callbackGraph(self,type,attribs,loc):
        self.__wInfo.setLoc(loc[0],loc[1])
        self.__wInfo.setType(type)
        self.__wInfo.setAttribs(attribs)
    def __argback(self,args):
        self.__canvas.AddArguments(args)


root = App()
root.pack()
root.master.title("JetScript")
root.mainloop()


