from Tkinter import *
from tkFileDialog import *
from JetWidget import JetWidget
from Connection import Connection
from SeqWidget import SeqWidget
class Visitor:
    def __init__(self):
        pass
    def Visit(self, widgets, connections):
        pass
    def PushStoppingPoint(self, w):
        print "Stop?"

def Escape_Backtics(escape_levels, command):
    backslashes = (pow(2, escape_levels) - 1) * '\\'
    return command.replace("`", backslashes + "`")

class WriteScriptVisitor(Visitor):
    VisitingFunctions = {}
    def __init__(self):
        Visitor.__init__(self)
        self.cli = 0
        self.header = ""


    def Script(self, widgets, connections):
        self.widgets = widgets
        self.connections = connections
        self.visited = [False for w in widgets]
        self.loopdetect = [False for w in widgets]
        self.output = ""
        self.escape = 0
        while False in self.visited:
            # Pick a widget:
            w = self.widgets[self.visited.index(False)]
            #DFS search to find the root of this pipeline.
            w.AcceptPipeSetPipeline(self)
            self.output += "\n"
        print self.output
        self.ScriptDialog(self.output)


    def Visit(self, node):
        #print self.VisitingFunctions
        print type(node)
        self.visited[self.widgets.index(node)] = True
        self.VisitingFunctions[node.__class__](self, node)

    def VisitedMe(self,node):
        print self.visited
        if self.visited[self.widgets.index(node)] == True:
            return True
        else:
            return False
        
    def setLooped(self,node):
        self.loopdetect[self.widgets.index(node)] = True

    def LoopDetected(self,node):
        if self.loopdetect[self.widgets.index(node)] == True:
            return True
        else:
            return False

    def AddCLI(self):
        self.output += Escape_Backtics(self.cli, " `")
        self.cli += 1

    def SubtCLI(self):
        self.cli -= 1
        self.output += Escape_Backtics(self.cli, " `")

    def AddParen(self):
        print "PAREN"
        self.output += "( "

    def SubtParen(self):
        print "PAREN"
        self.output += " )"

    def AddSemi(self):
        self.output += "; "
    
    def VisitJetWidget(self, node):
        self.output += Escape_Backtics(self.cli, node.command)
        if node.attribs:
            self.output += " " + node.attribs + " "



    def VisitConnectionWidget(self, node):
        pass

    def VisitSeqWidget(self, node):
        self.AddParen()
        node.VisitEach(self)
        self.SubtParen()

    def OutputPipe(self):
        self.output += " | "

    def OutputToFD(self):
        return ""

    def ScriptDialog(self,information):
        self.header = "# JetScript Generator v.1.0\n"+ information
        frame = Frame(Tk(),bd=2,relief=SUNKEN,height=800,width=600)
        frame.grid_rowconfigure(0, weight=1)
        frame.grid_columnconfigure(0, weight=1)

        xscrollbar = Scrollbar(frame, orient=HORIZONTAL)
        xscrollbar.grid(row=1, column=0, sticky=E+W)

        yscrollbar = Scrollbar(frame)
        yscrollbar.grid(row=0,column=1,sticky=N+S)
        
        text = Text(frame,wrap=WORD, bd=0,
                    yscrollcommand = yscrollbar.set,
                    xscrollcommand = xscrollbar.set)
        for line in self.header:
            text.insert(END,line)
        text.grid(row=0, column=0,sticky=N+E+S+W)

        Button(frame, text = "Click here to save",command=self.ScriptSave
               ).grid(row=2,column=0)

        xscrollbar.config(command=text.xview)
        yscrollbar.config(command=text.yview)

        frame.pack()

    def ScriptSave(self):
        name = asksaveasfilename()
        try:
            filename =  open(name,'w')
        except IOError:
            import tkMessageBox
            tkMessageBox.showerror("Save","Error opening save file")
            return
        filename.write(self.header)
        filename.close()
        return
    VisitingFunctions = {JetWidget:VisitJetWidget,
                         Connection:VisitConnectionWidget,
                         SeqWidget:VisitSeqWidget}
