from Tkinter import *
from ArgumentDirectory import *
import tkMessageBox

class WidgetInfo(Frame):
    def __init__(self, master, callback, argback):
        """A side dialog used to set attributes of a widget and move it around"""
        #Most of this function is just creating widgets.
        Frame.__init__(self,master)
        Label(self, relief=RIDGE, text = "Widget Information").grid(row=0,columnspan=2,pady=5)

        self._type=Label(self,text="Type: ")
        self._type.grid(row=1,columnspan=2,pady=5)
        
        self._attribs=Label(self,text="Attributes: ")
        self._attribs.grid(row=2,columnspan=2,pady=5)
        
        self._XEntry = Entry(self,bg="white",width=5)
        self._XEntry.grid(row=3,column=0)
        self._YEntry = Entry(self,bg="white",width=5)
        self._YEntry.grid(row=3,column=1)
        Label(self, text="X").grid(row=4,column=0)
        Label(self, text="Y").grid(row=4,column=1)
        Button(self, text="Move to Position",command=self.moveObject).grid(row=5,columnspan=2)

        Label(self,text=" ").grid(row=6,columnspan=2)
        self._argLabel = Label(self,text="Arguments:")
        self._argLabel.grid(row=7,columnspan=2)
        self._argEntry = Entry(self,bg="white",width=15)
        self._argEntry.grid(row=8,columnspan=2)
        self._argBut1 = Button(self, text="Enter",command=self.setArgs)
        self._argBut1.grid(row=9,column=0)
        self._argBut2 = Button(self, text="Help",command=self.runHelp)
        self._argBut2.grid(row=9,column=1)

        self._Argument = ArgumentDirectory()
        self._typeName = None
        self._moveback = callback
        self._argback = argback
        self.SHOW = 1


    def moveObject(self):
        try:
            x = int(self._XEntry.get())
            y = int(self._YEntry.get())
            
        except:
            tkMessageBox.showerror("Coordinates","Bad coordinates entered")
        self._moveback(x,y)

    def setLoc(self,x,y):
        self._XEntry.delete(0, END)
        self._XEntry.insert(0, int(x))
        self._YEntry.delete(0, END)
        self._YEntry.insert(0, int(y))

    def setType(self,text):
        self._type["text"]="Type: "+text
        self._typeName=text
       
    def setAttribs(self,text):
        self._attribs["text"]="Attributes: " + text
        
    def setArgs(self):
        text = self._argEntry.get()
        self._argback(text)
        self.setAttribs(text)
        
    def runHelp(self):
        self._Argument.load(self._typeName)



    #Next 3 functions might be useful

    def hideCheck(self):
        if self._Argument.exists(self._typeName) == "n" and self.SHOW == 1:
            self.hideArgs()
        else:
            if self.SHOW == 0:
                self.showArgs()
                
    def hideArgs(self):
        self._argLabel.grid_remove()
        self._argEntry.grid_remove()
        self._argBut1.grid_remove()
        self._argBut2.grid_remove()
        self.SHOW = 0

    def showArgs(self):
        self._argLabel.grid()
        self._argEntry.grid()
        self._argBut1.grid()
        self._argBut2.grid()
        
    #But I dont see myself using them anytime soon

