User Commands                                              cat(1)

NAME
     cat - concatenate and display files

SYNOPSIS
     cat [-nbsuvet] [file...]

DESCRIPTION
     The cat utility reads each file in sequence and writes it on
     the standard output. Thus:

     example% cat file
     prints file on your terminal, and:

     example% cat file1 file2 >file3
     concatenates file1 and file2,  and  writes  the  results  in
     file3.  If  no input file is given, cat reads from the stan-
     dard input file.

OPTIONS
     The following options are supported:

     -n    Precede each line output with its line number.

     -b    Number the lines, as -n, but  omit  the  line  numbers
           from blank lines.

     -u    The output is not buffered. (The default  is  buffered
           output.)

     -s    cat is silent about non-existent files.

     -v    Non-printing characters (with the exception  of  tabs,
           new-lines  and  form-feeds) are printed visibly. ASCII
           control characters (octal 000 - 037)  are  printed  as
           ^n,  where  n  is the corresponding ASCII character in
           the range octal 100 - 137 (@, A, B, C, . . ., X, Y, Z,
           [,  \, ], ^, and _); the DEL character (octal 0177) is
           printed ^?. Other non-printable characters are printed
           as  M-x,  where  x is the ASCII character specified by
           the low-order seven bits.

     When used with the -v option, the following options  may  be
     used:

     -e    A $ character will be printed at the end of each  line
           (prior to the new-line).


     -t    Tabs will be printed  as  ^I's  and  formfeeds  to  be
           printed as ^L's.

     The -e and -t options are ignored if the -v  option  is  not
     specified.