User Commands                                               nl(1)

NAME
     nl - line numbering filter

SYNOPSIS
     /usr/bin/nl [-p] [ -b [type]] [ -d [delim]] [ -f  [type]]  [
     -h  [type]]  [  -i  [incr]]  [ -l [num]] [ -n [format]] [ -s
     [sep]] [ -w [width]] [ -v [startnum]] [file]

     /usr/xpg4/bin/nl  [-p]  [-b type]  [-d delim]  [-f type]  [-
     h type]  [-i incr]  [-l num] [-n format] [-s sep] [-w width]
     [-v startnum] [file]

DESCRIPTION
     The nl command reads lines from the named file, or the stan-
     dard  input if no file is named, and reproduces the lines on
     the standard output.  Lines are  numbered  on  the  left  in
     accordance with the command options in effect.

     nl views the text it reads in terms of logical  pages.  Line
     numbering is reset at the start of each logical page. A log-
     ical page consists of a header, a body, and  a  footer  sec-
     tion.   Empty  sections  are valid. Different line numbering
     options are independently available for  header,  body,  and
     footer.  For  example,  -bt  (the default) numbers non-blank
     lines in the body section and does not number any  lines  in
     the header and footer sections.

     The start of logical page sections  are  signaled  by  input
     lines   containing   nothing  but  the  following  delimiter
     character(s):

            Line contents                    Start Of
                \:\:\:                        header
                 \:\:                          body
                  \:                          footer

     Unless optioned otherwise, nl assumes the text being read is
     in a single logical page body.

OPTIONS
     Command options may appear in any order and may be intermin-
     gled with an optional file name. Only one file may be named.
     The specified default is used when the option is not entered
     on the command line. /usr/xpg4/bin/nl options require option
     arguments.  A SPACE character   may  separate  options  from
     option arguments. /usr/bin/nl options  may have option argu-
     ments. If option-arguments of /usr/bin/nl  options  are  not
     specified,  these  options  result in the default.  The sup-
     ported options are:

     -btype

SunOS 5.9           Last change: 28 Mar 1995                    1

User Commands                                               nl(1)

           Specifies which logical page body lines are to be num-
           bered. Recognized types and their meanings are:

     a     number all lines

     t     number all non-empty lines.

     n     no line numbering

     pexp  number only lines that contain the regular  expression
           specified in exp; see NOTES below.

     Default type for logical page body is  t  (text  lines  num-
     bered).

     -ftype
           Same as -btype except for  footer.  Default  type  for
           logical page footer is n (no lines numbered).

     -ddelim
           The two delimiter characters specifying the start of a
           logical  page  section may be changed from the default
           characters (\:) to two user-specified  characters.  If
           only  one  character  is entered, the second character
           remains the default character  (:).  No  space  should
           appear between the -d and the delimiter characters. To
           enter a backslash, use two backslashes.

     -htype
           Same as -btype except for  header.  Default  type  for
           logical page header is n (no lines numbered).

     -iincr
           incr is the increment value  used  to  number  logical
           page lines. Default incr is 1.

     -lnum num is the number of blank lines to be  considered  as
           one. For example, -l2 results in only the second adja-
           cent blank being numbered  (if  the  appropriate  -ha,
           -ba, and/or -fa option is set). Default num is 1.

     -nformat
           format is the line numbering format. Recognized values
           are:

     ln    left justified, leading zeroes suppressed

     rn    right justified, leading zeroes suppressed

     rz    right justified, leading zeroes kept
